# iGibson Environment Maps

We used [iGibson](http://svl.stanford.edu/igibson/) floormaps to generate synthetic groups in realistic environments.
This data can only be used under [this agreement](http://svl.stanford.edu/gibson2/assets/GDS_agreement.pdf).
The data is strictly for non-commercial academic research only.

## Data Generation

We considered the 15 iGibson environments shown in the image below:

<img src="http://svl.stanford.edu/igibson/docs/_images/ig_scene.png" width="400"/>

The environments were downloaded following the
[iGibson installation instructions](http://svl.stanford.edu/igibson/docs/installation.html) via the command
`python -m gibson2.utils.assets_utils --download_ig_dataset`. Then, for each environment, we generated new
layouts using the script `generate_trav_maps.py`. Finally, we used these layouts to create environment maps for
the pose generation methods.

The next sections describe the above steps in detail.

### Generating iGibson Layouts

1. Create a virtual environment with Python 3.8 or higher for iGibson

    ```bash
    $ python3.8 -m venv venv-igibson
    $ source venv-igibson/bin/activate
    ```
   
2. Install dependencies using the `requirements.txt` file in this directory

    ```bash
    (venv-igibson) $ pip install -r requirements.txt
    ```

3. Download iGibson data

    ```bash
    (venv-igibson) $ python -m gibson2.utils.assets_utils --download_ig_dataset
    ```
   
4. Re-generate maps

    ```bash
    (venv-igibson) $ generate_igibson_maps.sh ../data/igibson_maps
    ```
   
   The script above will run the `generate_trav_maps.py` script for all iGibson environments and save the results
   in the `../data/igibson_maps` folder. This is a slow process. Be patient. 
   The output directory then have the following structure:

   ```text
   - igibson_maps               
   |- Benevolence_0_int             # each scene has a folder
      |- floor_0.png                # outline of environment without objects
      |- objects_0.png              # outline of environment only with objects
      |- floor_trav_0.png           # traversable map of the environment without objects
      |- objects_trav_0.png         # traversable map of objects only
      |- trav.log                   # log of generate_trav_maps.py output
   |- Benevolence_1_int             
   |- (...)
   ```

Note that we manually edited the maps using Photoshop to fill gaps for obstacles that were not fully identified with the above scripts.
For example, the images below show an original map (left) and the same map after manual improvement (right):


<img src="../documentation/images/igibson_json_beechwood_0.png" width="200"/>

<img src="../documentation/images/igibson_json_beechwood_0_manual.png" width="200"/>

### Creating Environment Maps

For convenience, we have placed the (manually improved) maps in Google Drive. These maps should only be accessed if you've already agreed to the above [data usage agreement for iGibson](http://svl.stanford.edu/gibson2/assets/GDS_agreement.pdf).

1. Download the maps from [here](https://drive.google.com/drive/folders/13JmpWbr8JEcpZMtsI-AsAu4LWdqZlRsd). Place the data within `data/igibson_layouts` folder inside the repository for this project.

   The layout data is structured as follows: there is one directory for each iGibson environment, and within that folder there are 4 layouts. Two layouts are outlines of elements in the environment. One is an outline of rigid elements like walls and tall objects. The other one is an outline of smaller, short obstacles. In the same folder, there are also two layouts that are meant to cover the area used by tall and short obstacles. The latter two files correspond to `floor_trav_0.png` and `objects_trav_0.png`.

2. Run the following script to convert the layouts from png to json format, similar to the other environment maps that we use for this project.

    ```bash
    $ python make_igibson_env_maps.py --ig-dataset ../data/igibson_layouts/ -v --output-dir ../data/igibson_json/
    ```

    If you want to visualize the maps that are being generated, use the `-p` option with the above script. 

### Visualizing environment maps for iGibson

Once the environment maps have been generated as in the prior section, you can use the following tool in the `bin` folder to visualize them:

```bash
$ python visualize_env_json.py ../data/igibson_json/env_Beechwood_0_int.txt
```

where the second argument is the path to any of the json files generated by `make_igibson_env_maps.py`.

